Tempesta.Barrel = function(game) {};
Tempesta.Barrel.prototype = {
    preload: function () {
    this.game.load.image('sky', 'assets/sky.png');
    this.game.load.image('ground', 'assets/platform.png');
    this.game.load.spritesheet('red_dot', 'assets/jumper.png', 18, 39);
    this.game.load.image('yellow_dot', 'assets/barrel1.png');
    this.game.load.image('button','assets/jump_button.png');
    },
    
    
    create : function()  {
        //mc = new Hammer.Manager(game);
        console.log("Game mode " + Session.game_mode);
        time=0;
        time0=0;
        frame_tick=0;
        this.game.physics.startSystem(Phaser.Physics.ARCADE);
        this.game.add.sprite(0, 0, 'sky');
        platforms = this.game.add.group();
        platforms.enableBody = true;
        numBarrels= 5;
        
        score = 0;
        // Here we create the ground.
        ground = platforms.create(-800, this.game.world.height - 64, 'ground');
        //  Scale it to fit the width of the game (the original sprite is 400x32 in size)
        ground.scale.setTo(4, 2);
        //  This stops it from falling away when you jump on it
        ground.body.immovable = true;
        
        // Here we create the ground.
        ground = platforms.create(-1200, this.game.world.height - 96, 'ground');
        ground.scale.setTo(4, 1);
        ground.body.immovable = true;
        
        ground = platforms.create(-1400, this.game.world.height - 128, 'ground');
        ground.scale.setTo(4, 1);
        ground.body.immovable = true;
        
        // The player and its settings
        player = this.game.add.sprite(this.game.world.width-60 , this.game.world.height - 150, 'red_dot');
        player.scale.setTo(1.5, 1.5);
        
        //  We need to enable physics on the player
        this.game.physics.arcade.enable(player);
        
        //  Player physics properties. Give the little guy a slight bounce.
        player.body.bounce.y = 0.2;
        player.body.gravity.y = 300;
        player.body.collideWorldBounds = true;
        player.body.velocity.x = 0;
        player.body.velocity.y = 0;
        
        
        //  Finally some barrels to avoid
        barrels = this.game.add.group();
        
        //  We will enable physics for any barrel that is created in this group
        barrels.enableBody = true;
        
        //  Here we'll create 12 of them evenly spaced apart
        for (var i = 0; i < numBarrels; i++)
        {
            //  Create a barrel inside of the 'barrels' group
            barrel = barrels.create(i * 70 - 700, 100, 'yellow_dot');
            
            //  Let gravity do its thing
            barrel.body.gravity.y = 300;
            barrel.body.velocity.x = 70 + Math.random() * 200 ;
            barrel.body.velocity.y = Math.random() * 100 ;
            barrel.anchor.setTo(0.5,0.5);
            barrel.angle = 360 * Math.random();
            barrel.scale.setTo(0.5,0.5);
            //        barrel.body.collideWorldBounds = true;
            
            barrel.body.bounce.y = 0.5 ;
        }
        
        //  The score
        scoreText = this.game.add.text(16, 16, 'score: 0', { fontSize: '32px', fill: '#000' });
        
        //  Our controls.
        //cursors = this.game.input.keyboard.createCursorKeys();
        //this.game.input.onTap.add(this.onTap,this);
        button=this.game.add.button(this.game.width/2, this.game.height- 40, 'button', this.actionOnClick, this);
        button.scale.setTo(0.5,0.5);
        //button.scale=0.5;
        button.anchor= new PIXI.Point(0.5,0.5);
        
        time0 = 3 + Math.random() * 3;
        doJump=false;
        
    },

    update: function() {
        
        time = time + 0.01;
        
        //  Collide the player and the barrels with the platforms
        this.game.physics.arcade.collide(player, platforms);
        this.game.physics.arcade.collide(barrels, platforms);
        //    game.physics.arcade.collide(barrels, player);
        this.game.physics.arcade.collide(barrels, barrels);
        
        //  Checks to see if the player overlaps with any of the barrels, if he does call the collectStar function
        this.game.physics.arcade.overlap(player, barrels, this.muerte, null, this);
        
        //  Reset the players velocity (movement)
        player.body.velocity.x = 0;
        
        
        posx = this.game.world.width + 10 ;
        for (var i = 0; i < numBarrels; i++)
        {
            //  Create a barrel inside of the 'barrels' group
            barrel = barrels.children[i] ;
            barrel.angle +=  1;   
            //  Let gravity do its thing
            posx = Math.min(barrel.body.position.x, posx) ;
        }
        
        //  Allow the player to jump if they are touching the ground.
        //if (cursors.up.isDown && player.body.touching.down)
        if(doJump && player.body.touching.down)
        {
            player.body.velocity.y = -350;
        }
        doJump = false;
        
        if ( time > time0 && posx > this.game.world.width)
        {
            score+=1;
            scoreText.text = 'score:'+score;
            
            for (var i = 0; i < numBarrels; i++)
            {
                //  Create a barrel inside of the 'barrels' group
                barrel = barrels.children[i]
                
                //  Let gravity do its thing
                barrel.body.position.x = i * 70 - 700
                barrel.body.position.y = 100
                barrel.body.velocity.x = 70 + Math.random() * 200 ;
                barrel.body.velocity.y = Math.random() * 100 ;
                barrel.body.gravity.y  = 300;
                
                barrel.body.bounce.y = 0.5 ;
            }
            time0 = time + 3 + Math.random() * 3
        }

        if (score==2)
        {
            this.game.state.start("Game");
        }

        if (frame_tick % Math.floor(Tempesta.refresh*3/50) == 0)
            {
            Tempesta.net.ws.send(JSON.stringify(Session));  
            //console.log(JSON.stringify(Session));
            }
        frame_tick+=1;
    },
    
    muerte: function  (player, barrel) {
        
        
        if ( player.body.position.y <= barrel.body.position.y + 10 )
        {
            // Removes the player from the screen
            player.kill();
            this.game.state.start("Game");
            //  Add and update the score
            //scoreText.text = ' Player is dead  at time ' + time + ' score : '+ score
        }
        else
        {
            var vel = ( barrel.body.velocity.y + player.body.velocity.y )
            barrel.body.velocity.y = vel - barrel.body.velocity.y 
            player.body.velocity.y = vel - player.body.velocity.y 
        }
        
        
    },
    
    actionOnClick: function () {
        
        doJump=true;
        
    }
    
}    
    
    
